package com.fp.persistence.pgeneral.safe;

import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.Column;
import javax.persistence.EntityManager;
import java.io.Serializable;
import java.math.BigDecimal;
import javax.persistence.Table;
import com.fp.dto.hb.HibernateBean;
import javax.persistence.Version;
import java.lang.reflect.Field;
import javax.persistence.Transient;

/**Clase que implementa la entidad de Hibernate que hace referencia a la tabla TSAFEPROFILEHORARYAMOUNT*/
@Entity(name="TsafeProfileHoraryAmount")
@Table(name="TSAFEPROFILEHORARYAMOUNT")
public class TsafeProfileHoraryAmount extends com.fp.dto.AbstractDataTransport implements Serializable,HibernateBean,Cloneable{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
/**
* Clave primaria de la Entidad TsafeProfileHoraryAmount
*/
@EmbeddedId
private TsafeProfileHoraryAmountKey pk;
@Version
@Column(name="RECORDVERSION", nullable=true)

/**
* optimistic locking del registro
*/
private Integer recordversion;

@Column(name="AMOUNT", nullable=true)

/**
* Monto maximo permitido para la transaccion moneda.
*/
private BigDecimal amount;

/**Contructor por defecto*/
public TsafeProfileHoraryAmount(){
}
/**Contructor de TsafeProfileHoraryAmount
@param pPk Clave Primaria del entity
*/
public TsafeProfileHoraryAmount(TsafeProfileHoraryAmountKey pPk){
 this();
 pk=pPk;
}
/**
* Metodo que entrega datos de la tabla dada la clave primaria.
* @param pEntityManager referencia de la session a obtener datos del bean.
* @param pKey Caleve primaria del bean.
* @return TsafeProfileHoraryAmount
*/
public static TsafeProfileHoraryAmount find(EntityManager pEntityManager,TsafeProfileHoraryAmountKey pKey) throws Exception{
    TsafeProfileHoraryAmount obj = pEntityManager.find(TsafeProfileHoraryAmount.class,pKey);
    return obj;
}
/**Entrega la Clave primaria de TsafeProfileHoraryAmount
@return El objeto que referencia a la Clave primaria de TsafeProfileHoraryAmount
*/
public TsafeProfileHoraryAmountKey getPk(){
  return pk;
}
/**Fija un nuevo valor a la Clave primaria de TsafeProfileHoraryAmount
@param pPk El objeto que referencia a la nueva Clave primaria de TsafeProfileHoraryAmount
*/
public void setPk(TsafeProfileHoraryAmountKey pPk){
  pk=pPk;
}
/**Obtiene el valor de recordversion
@return valor de recordversion*/
public Integer getRecordversion(){
  return recordversion;
}
/**Fija el valor de recordversion
@param pRecordversion nuevo Valor de recordversion*/
public void setRecordversion(Integer pRecordversion){
  recordversion=pRecordversion;
}

/**Obtiene el valor de amount
@return valor de amount*/
public BigDecimal getAmount(){
  return amount;
}
/**Fija el valor de amount
@param pAmount nuevo Valor de amount*/
public void setAmount(BigDecimal pAmount){
  amount=pAmount;
}

public boolean equals(Object rhs){
    if (rhs == null)return false;
    if (! (rhs instanceof TsafeProfileHoraryAmount))return false;
    TsafeProfileHoraryAmount that = (TsafeProfileHoraryAmount) rhs;
    if (this.getPk() == null || that.getPk() == null)
        return false;
    return (this.getPk().equals(that.getPk()));
}
/**Implementación del metodo hashCode de la la entidad TsafeProfileHoraryAmount
@return el hashCode la instancia
*/
public int hashCode()    {
    if (this.hashValue == 0){
        int result = 17;
        if (this.getPk() == null){
            result = super.hashCode();
        }else{
            result = this.getPk().hashCode();
        }
        this.hashValue = result;
    }
    return this.hashValue;
}
/**Implementación toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+=name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
/**Implementación de la creación de un bean en blanco TsafeProfileHoraryAmount
*/
public Object createInstance(){
 TsafeProfileHoraryAmount instance=new TsafeProfileHoraryAmount();	
 instance.setPk(new TsafeProfileHoraryAmountKey());
 return instance;
}
/**Clona la entidad TsafeProfileHoraryAmount
@see com.fp.dto.hb.HibernateBean#cloneMe()
*/
public Object cloneMe() throws CloneNotSupportedException{
  TsafeProfileHoraryAmount p=(TsafeProfileHoraryAmount)this.clone();
  p.setPk((TsafeProfileHoraryAmountKey)this.pk.cloneMe());
  return p;
}
}
